//
//  XLDCustomClasses.h
//  XLD
//
//  Created by tmkk on 09/02/14.
//  Copyright 2009 tmkk. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface XLDView : NSView {
	int tag;
}

- (int)tag;
- (void)setTag:(int)t;

@end

@interface XLDTextView : NSTextView {
	id actionTarget;
}

- (NSMenu *)menuForEvent:(NSEvent *)event;
- (void)setActionTarget:(id)target;

@end

@interface NSImage (String)
+ (NSImage *)imageWithString:(NSString *)string withFont:(NSFont *)font withColor:(NSColor *)color;
@end

@interface NSSavePanel (__HackyBlizzardNewFolderCategory)
- (void)_setIncludeNewFolderButton:(BOOL)yn;
@end

@interface XLDButton : NSButton {
	int modifierFlags;
}

- (BOOL)commandKeyPressed;
- (BOOL)optionKeyPressed;
- (BOOL)shiftKeyPressed;

@end

@interface XLDTrackListUtil : NSObject {	
}

+ (NSString *)artistForTracks:(NSArray *)tracks;
+ (NSString *)artistForTracks:(NSArray *)tracks sameArtistForAllTracks:(BOOL*)allSame;
+ (NSString *)dateForTracks:(NSArray *)tracks;
+ (NSString *)genreForTracks:(NSArray *)tracks;
+ (NSString *)albumTitleForTracks:(NSArray *)tracks;
+ (NSMutableData *)cueDataForTracks:(NSArray *)tracks withFileName:(NSString *)filename appendBOM:(BOOL)appendBOM;
+ (NSMutableData *)nonCompliantCueDataForTracks:(NSArray *)trackList withFileNameArray:(NSArray *)filelist appendBOM:(BOOL)appendBOM gapStatus:(unsigned int)status;

@end

@interface NSFileManager (IntermediateDirectoryHiddenMethod)
- (BOOL)_web_createDirectoryAtPathWithIntermediateDirectories:(NSString *)path attributes:(NSDictionary *)attributes;
#if MAC_OS_X_VERSION_MAX_ALLOWED < MAC_OS_X_VERSION_10_5
- (BOOL)createDirectoryAtPath:(NSString *)path withIntermediateDirectories:(BOOL)createIntermediates attributes:(NSDictionary *)attributes error:(NSError **)error;
#endif
@end

@interface NSFileManager (IntermediateDirectory)
- (void)createDirectoryWithIntermediateDirectoryInPath:(NSString *)path;
@end

@interface NSMutableDictionary (NSUserDefaultsCompatibility)
- (void)setInteger:(int)value forKey:(NSString *)defaultName;
- (void)setBool:(BOOL)value forKey:(NSString *)defaultName;
@end

@interface XLDSplitView : NSSplitView {
}
@end

#if MAC_OS_X_VERSION_MAX_ALLOWED < MAC_OS_X_VERSION_10_5
@interface NSTableView (HighlightStyle)
- (void)setSelectionHighlightStyle:(int)selectionHighlightStyle;
@end
#endif

@interface XLDAdaptiveTexturedWindow : NSWindow {
}
@end

@interface NSWorkspace (IconAdditions)
- (NSImage *)iconForFolder;
- (NSImage *)iconForDisc;
- (NSImage *)iconForBurn;
@end

@interface NSData (FasterSynchronusDownload)
+ (NSData *)fastDataWithContentsOfURL:(NSURL *)url;
@end

@interface NSFlippedView : NSView {
}
@end

